;; ModificaciÃ³n a la funciÃ³n original "rule-apply" que revisa si los secuentes
;; resultantes de la aplicaciÃ³n de una regla, pueden ser maquillados como fÃ³rmulas
;; Alloy. Si no se puede, se cancela la aplicaciÃ³n de la regla.
(defun rule-apply (step ps)
  (let* ((*ps* ps)
	 (* '*)
	 (*goal* (current-goal ps))
	 (*label* (label  ps))
	 ;; (*subgoalnum* (subgoalnum ps))
	 (*+* (mapcar #'formula (pos-s-forms (current-goal ps))))
	 (*-* (mapcar #'formula (neg-s-forms (current-goal ps))))
	 (*par-label* (when (parent-proofstate ps)
			(label (parent-proofstate ps))))
	 (*par-goal* (when (parent-proofstate ps)
		       (current-goal (parent-proofstate ps))))
	 (*current-context* *current-context*)
	 (*module-context* (copy-prover-context))
	 (*current-theory* *current-theory*)
	 (*auto-rewrites* (rewrites ps))
	 (*all-rewrites-names* (all-rewrites-names ps))
	 (*auto-rewrites-names* (auto-rewrites-names ps))
	 (*auto-rewrites!-names* (auto-rewrites!-names ps))
 	 (*macro-names* (macro-names ps))	 
	 (*rewrite-hash* (rewrite-hash ps))
	 (*dp-state* (dp-state ps)))
    ;;(break)
    (cond ((typep step 'rule-instance);;if step is a rule, then
	   ;;reinvoke rule-apply with corresponding strategy. 
	   (rule-apply (make-instance 'strategy
			 :topstep step)
		       ps));;else step is a strategy
	  ((typep (topstep step) 'rule-instance)
	   (let* ((*tccforms* nil)
		  (topstep (topstep step))
		  (name (if (consp (rule-input topstep))
			    (car (rule-input topstep))
			    topstep))
		  (*suppress-printing* (or *suppress-printing*
					   (eq name 'lisp))))
	     (when (memq name *ruletrace*)
	       (format t "~%~vTEnter: ~a" *ruletracedepth*
		       (rule-input topstep))
	       (incf *ruletracedepth*))
	     (multiple-value-bind (signal subgoals updates)
		 (funcall (rule topstep) ps);;(break "rule-ap")
	       (cond ((eq signal '!);;success
		      (when (memq name *ruletrace*)
			(decf *ruletracedepth*)
			(format t "~%~vT Exit: ~a -- Proved subgoal"
			  *ruletracedepth* name ))
		      (when (eq (car (rule-input topstep)) 'apply)
			(let ((timeout-sect
			       (memq :timeout (rule-input topstep))))
			  (when timeout-sect
			    (setf (rule-input topstep)
				  (append (ldiff (rule-input topstep)
						 timeout-sect)
					  (cddr timeout-sect))))))
		      (setf (status-flag ps) '!      
			    (current-rule ps) (rule-input topstep)
			    (parsed-input ps) (sublis (remove-if #'null
								*rule-args-alist*
								:key #'cdr)
							      (rule-input topstep))
			    (printout ps) (sublis (remove-if #'null
						    *rule-args-alist*
						    :key #'cdr)
						  (rule-format topstep))
			    (justification ps) (make-instance 'justification
						 :label (label-suffix (label ps))
						 :rule (rule-input topstep)
						 :comment (new-comment ps)))
		      (make-updates updates ps)
		      ps)
		     ((eq signal '?);;subgoals generated
		      ;; Dynamite-specific
		      ;; Antes de procesar el resultado de la aplicaciÃ³n de la regla,
		      ;; me fijo si los secuentes resultantes pueden ser maquillados
		      ;; como fÃ³mulas Alloy. Si no se puede, cancelo la aplicaciÃ³n.
		      (handler-case	   
		       (progn 
			 (when *dps-pp-activated* (with-output-to-string
			   (*standard-output*)
			   (loop for sg in subgoals
				 do (if (consp sg)
					(loop for ssg in sg
					      do (when (sequent? ssg) (format-if "~a" (s-forms ssg))))
				      (when (sequent? sg) (format-if "~a" (s-forms sg)))))))
			 (make-updates updates ps)
			 ;;(NSH:5/1/99)make-updates should be above
			 ;;make-subgoal-proofstates
			 ;;so that the proof-dependent-decls can be computed.
			 (let* ((*tccforms* (remove-duplicates *tccforms*
							       :test #'tc-eq
							       :key #'tccinfo-formula))
				(tcc-hash-counter 0)
				(*tccforms*
				 (loop for tcc in *tccforms*
				    when (or
					  (null (gethash
						 (tccinfo-formula tcc)
						 (tcc-hash ps)))
					  (and (incf tcc-hash-counter)
					       nil))
				    collect tcc))
			     (new-tcc-hash
			      (if *tccforms*
				  (copy (tcc-hash ps))
				  (tcc-hash ps)))
			     (tccforms (assert-tccforms *tccforms* ps))
			     (false-tccforms
			      (loop for tccform in *tccforms*
				    as assert-tccform in tccforms
				    when (tc-eq (tccinfo-formula assert-tccform)
						*false*)
				    collect tccform)))
			(cond (false-tccforms
			       ;;treated as a skip
			       (unless *suppress-printing*
				 (format t "~%No change. False TCCs: ~%~{  ~a, ~%~}"
				   (mapcar #'tccinfo-formula false-tccforms)))
			       (setf (status-flag ps) nil;;start afresh
				     (strategy ps)
				     (failure-strategy step))
			       ps)
			      (t (let* ((tcc-subgoals
				    (mapcar
					#'(lambda (x)
					    (let ((y 
						   (change-class
						    (copy (current-goal ps)
						      's-forms
						      (cons
						       (make-instance
							   's-formula
							 :formula
							 (tccinfo-formula x))
						       (s-forms
							(current-goal ps))))
						    'tcc-sequent)))
					      (setf (tcc y)
						    (tccinfo-formula x)
						    (reason y)
						    (tccinfo-reason x)
						    (expr y)
						    (tccinfo-expr x)
						    (kind y)
						    (tccinfo-kind x)
						    (type y)
						    (tccinfo-type x))
					      y))
				      tccforms))
				   (subgoal-proofstates
				    (make-subgoal-proofstates
				     ps
				     (subgoal-strategy step)
				     subgoals
				     tcc-subgoals
					;updates;must be attached to subgoals.
				     )))
			      ;;cleaning up (NSH 7.27.94)
			      ;;1. convert main subgoals of tccs into
			      ;;non-tccs.
			      ;;2. hash the new tccs into new-tcc-hash
			      ;;3. set tcc-hash of main subgoals as
			      ;;new-tcc-hash
			      (when (> tcc-hash-counter 0)
				(format-if "~%Ignoring ~a repeated TCCs."
					   tcc-hash-counter))
			      (loop for tcc in *tccforms*
				    do
				    (setf (gethash (tccinfo-formula tcc)
						   new-tcc-hash)
					  t))
			      (assert
			       (every #'(lambda (sps)
					  (every #'(lambda (sfmla)
						     (null (freevars (formula sfmla)))
						     )
						 (s-forms (current-goal sps))))
				      subgoal-proofstates))
			      (loop for sps in subgoal-proofstates
				    when (not (tcc-proofstate? sps))
				    do (setf (tcc-hash sps)
					     new-tcc-hash))
			      (when (memq name *ruletrace*)
				(decf *ruletracedepth*)
				(format t "~%~vT Exit: ~a -- ~a subgoal(s) generated."
					*ruletracedepth* name (length subgoal-proofstates)))
			      (push-references *tccforms* ps)
			      (when (eq (car (rule-input topstep)) 'apply)
				(let* ((rinput (rule-input topstep))
				       (mtimeout (memq :timeout rinput)))
				  (if mtimeout
				      ;; Given by keyword
				      (setf (rule-input topstep)
					    (append (ldiff rinput mtimeout)
						    (cddr mtimeout)))
				    ;; Positional
				    (when (and (not (some #'keywordp rinput))
						 (> (length rinput) 4))
				      (assert (= (length rinput) 5))
				      (setf (rule-input topstep)
					    (butlast rinput))))))
			      (setf (status-flag ps) '?
				    (current-rule ps) (rule-input topstep)
				    (parsed-input ps) (sublis (remove-if #'null
								*rule-args-alist*
								:key #'cdr)
							      (rule-input topstep))
				    (printout ps) (sublis (remove-if #'null
								     *rule-args-alist*
								     :key #'cdr)
							  (rule-format topstep))
				    (remaining-subgoals ps) subgoal-proofstates)
			      (unless (typep ps 'top-proofstate)
				(setf (strategy ps) nil))
			      ps)))))
		 (not-prettyprintable-elem-error
		  ()
		  (progn
		    (error-format-if "ABORT: The application of the rule would result in a PDOCFA sequent that can't be translated back to Alloy.")
		    (when (memq name *ruletrace*)
			   (decf *ruletracedepth*)
			   (format t "~%~vT Exit: ~a -- No change."
				   *ruletracedepth* name))
			 (unless *suppress-printing*		 
			   (format t "~%No change on: ~s" (rule-input topstep)))
			 (setf (status-flag ps) nil;;start afresh
			       (strategy ps)
			       (failure-strategy step))
			 (make-updates nil ps)
			 ps))))
		     ((eq signal 'X)
		      (when (memq name *ruletrace*)
			(decf *ruletracedepth*)
			(format t "~%~vT Exit: ~a -- No change."
			  *ruletracedepth* name))
		      (unless *suppress-printing*
			(explain-errors)
			(format t "~%No change on: ~s" (rule-input topstep)))
		      (setf (status-flag ps) nil;;start afresh
			    (strategy ps)
			    (failure-strategy step))
		      (make-updates updates ps)
		      ps)
		     ((eq signal 'XX);;marks the current goal a failure
		      (setf (status-flag ps) 'XX)
		      ps)
		     ((eq signal '*)
		      (setf (status-flag ps) '*)
		      ps)
		     (t  (undo-proof signal ps))))))
	  ((typep (topstep step) 'strategy)
	   (setf (status-flag ps) '?
		 ;;		 (current-rule ps) (strategy-input rule)
		 (remaining-subgoals ps)
		 (make-subgoal-proofstates ps
					   (topstep step)
					   (list (current-goal ps))))
					;nil
	   ps)
	  (t (format t "~%Bad rule: ~a~%" step);;treated as skip
					;(break)
	     (setf (status-flag ps) nil;;start afresh
		   (strategy ps)
		   (failure-strategy (strategy ps)))
	     ps))))
